From b34eb38f05d3b2846d40dddedcce5bd055d97f2a Mon Sep 17 00:00:00 2001
From: MatheusMello <mat.mello93@gmail.com>
Date: Nov 09 2017 18:46:02 +0000
Subject: [PATCH 2/3] updating with upstream


---

diff --git a/.gitignore b/.gitignore
index 74f8033..f14e4e1 100644
--- a/.gitignore
+++ b/.gitignore
@@ -5,6 +5,8 @@ npm-debug.log*
 yarn-debug.log*
 yarn-error.log*
 test/unit/coverage
+*lock.json
+package-lock.json
 
 # Editor directories and files
 .idea
diff --git a/src/App.vue b/src/App.vue
index 0ec5f1f..15a6666 100644
--- a/src/App.vue
+++ b/src/App.vue
@@ -1,6 +1,7 @@
 <template>
-  <div id="app"> 
-    <router-view></router-view>
+  <div id="app">
+    <header-kiskadee />
+    <router-view />
   </div>
 </template>
 
@@ -9,12 +10,15 @@ import Vue from 'vue'
 import VueMaterial from 'vue-material'
 import 'vue-material/dist/vue-material.css'
 import Vuex from 'vuex'
+import HeaderK from './components/shared/HeaderK'
 
 Vue.use(VueMaterial)
 Vue.use(Vuex)
 
 export default {
-
+  components: {
+    'header-kiskadee': HeaderK
+  }
 }
 </script>
 
diff --git a/src/api/index.js b/src/api/index.js
index 7982ba4..c71f91d 100644
--- a/src/api/index.js
+++ b/src/api/index.js
@@ -2,7 +2,7 @@ import axios from 'axios'
 
 let axiosApi = axios.create({
   baseURL: 'http://localhost:5000',
-  timeout: 1000
+  timeout: 3000
 })
 
 export default axiosApi
diff --git a/src/components/home/Home.vue b/src/components/home/Home.vue
index 7341376..7a37d39 100644
--- a/src/components/home/Home.vue
+++ b/src/components/home/Home.vue
@@ -1,17 +1,18 @@
 <template>
   <div>
-    <header-kiskadee></header-kiskadee>
+    <search></search>
     <list-packages></list-packages>
   </div>
 </template>
 
 <script>
-import HeaderK from '../shared/HeaderK.vue'
-import List from '../packages/List.vue'
+import List from '../package/List.vue'
+import Search from '../package/Search.vue'
 
 export default {
+  name: 'home',
   components: {
-    'header-kiskadee': HeaderK,
+    'search': Search,
     'list-packages': List
   }
 }
@@ -19,4 +20,4 @@ export default {
 
 <style lang="scss" scoped>
 
-</style>
\ No newline at end of file
+</style>
diff --git a/src/components/package/ErrorsTable.vue b/src/components/package/ErrorsTable.vue
new file mode 100644
index 0000000..1579cf9
--- /dev/null
+++ b/src/components/package/ErrorsTable.vue
@@ -0,0 +1,100 @@
+<template>
+<div>
+  <b-card header-tag="header" footer-tag="footer">
+    <!-- <h6 slot="header" class="mb-0">
+            <div class="my-1 row">
+                <div class="col-md-6">
+                    <b-form-fieldset horizontal label="Rows per page" :label-cols="6">
+                        <b-form-select :options="pageOptions" v-model="perPage" />
+                        </b-form-fieldset>
+                    </div>
+                    <div class="col-md-6">
+                        <b-form-fieldset horizontal label="Filter" :label-cols="3">
+                            <b-form-input v-model="filter" placeholder="Type to Search" />
+                            </b-form-fieldset>
+                        </div>
+                    </div>
+                </h6> -->
+    <em slot="footer">
+      <b-pagination align="center" :total-rows="totalRows" :per-page="perPage" v-model="currentPage"/>
+    </em>
+    <p class="card-text">
+      <b-table striped hover show-empty
+      :items="correctList"
+      :fields="fields"
+      :current-page="currentPage"
+      :per-page="perPage"
+      :sort-by.sync="sortBy"
+      :sort-desc.sync="sortDesc"
+      ></b-table>
+    </p>
+  </b-card>
+</div>
+</template>
+
+<script>
+import { mapGetters } from 'vuex'
+import * as getterNames from '../../store/getterNames.js'
+
+export default {
+  data () {
+    return {
+      fields: {
+        type: {
+          label: 'Type',
+          sortable: true,
+          'class': 'text-center'
+        },
+        path: {
+          label: 'Path',
+          sortable: true
+        },
+        line: {
+          label: 'Line : Column'
+        },
+        message: {
+          label: 'Message'
+        }
+      },
+      totalRows: this.total,
+      currentPage: 1,
+      perPage: 10,
+      sortBy: 'type',
+      sortDesc: false
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.errorsList
+    ]),
+    total () {
+      return this.errorsList.length
+    },
+    correctList () {
+      return this.makeErrorsTable()
+    }
+  },
+  methods: {
+    makeErrorsTable () {
+      let errorsList = this.errorsList.map((errorsObject) => {
+        const returnError = {}
+        returnError.type = errorsObject.testid
+        if (errorsObject.location) {
+          const lineColumn = `${errorsObject.location.point.line} : ${errorsObject.location.point.column}`
+          returnError.path = errorsObject.location.file.givenpath
+          returnError.line = lineColumn
+        }
+        if (errorsObject.message) {
+          returnError.message = errorsObject.message.text
+        }
+        return returnError
+      })
+      return errorsList
+    },
+    onFiltered (filteredItems) {
+      this.totalRows = filteredItems.length
+      this.currentPage = 1
+    }
+  }
+}
+</script>
diff --git a/src/components/package/List.vue b/src/components/package/List.vue
new file mode 100644
index 0000000..063edc1
--- /dev/null
+++ b/src/components/package/List.vue
@@ -0,0 +1,128 @@
+<template>
+  <div class="container list-pkgs">
+    <div class="row">
+      <div class="col-md-12">
+        <div class="alert">
+          <b-alert :show="sucessCountDown"
+                   dismissible
+                   variant="success"
+                   @dismissed="sucessCountDown=0"
+                   @dismiss-count-down="successCountDownChanged">
+            Packages successfully imported! ({{sucessCountDown}})
+          </b-alert>
+          <b-alert :show="errorCountDown"
+                   dismissible
+                   variant="danger"
+                   @dismissed="errorCountDown=0"
+                   @dismiss-count-down="errorCountDownChanged">
+            Packages not imported! ({{errorCountDown}})
+          </b-alert>
+        </div>
+      </div>
+    </div>
+
+    <div class="row table-meta-data">
+      <div class="col-md-5">
+        <b-button :disabled="disabled" variant="outline-primary sm" v-if="notUpdating" @click="this.updateTable"><icon name="refresh" scale="1.5"></icon> &nbsp &nbsp Update Table</b-button>
+        <b-button :disabled="disabled" variant="primary sm" v-else><icon spin name="refresh" scale="1.5"></icon> &nbsp &nbsp Updating</b-button>
+        <span class="date text-muted">Last updated {{ this.updateData }}</span>
+      </div>
+    </div>
+    <b-table striped hover :items="allPackages" height="100" @row-clicked="showPackage"></b-table>
+  </div>
+</template>
+
+<script>
+import { mapActions, mapGetters } from 'vuex'
+import * as actionTypes from '../../store/actionTypes.js'
+import * as getterNames from '../../store/getterNames.js'
+import moment from 'moment'
+
+export default {
+  data () {
+    return {
+      updateData: null,
+      notUpdating: true,
+      disabled: false,
+      searchDef: {
+        show: false
+      },
+      currentRow: null,
+      timer: '',
+      dismissSecs: 3,
+      sucessCountDown: 0,
+      errorCountDown: 0
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.allPackages
+    ])
+  },
+  methods: {
+    ...mapActions([
+      actionTypes.FETCH_PACKAGES
+    ]),
+    showPackage (item) {
+      this.$router.push({
+        name: 'analysis',
+        params: {
+          package: item
+        }
+      })
+    },
+    updateTable () {
+      this.notUpdating = false
+      this.fetchPackages().then(async response => {
+        this.showAlert(response)
+        setTimeout(() => {
+          this.notUpdating = true
+        }, 1000)
+      })
+      this.updateData = moment().calendar()
+    },
+    updateAnimation () {
+      this.notUpdating = true
+      setTimeout(function () { console.log(this.notUpdating) }, 3000)
+    },
+    successCountDownChanged (sucessCountDown) {
+      this.sucessCountDown = sucessCountDown
+    },
+    errorCountDownChanged (errorCountDown) {
+      this.errorCountDown = errorCountDown
+    },
+    showAlert (sucessMessage) {
+      if (sucessMessage === true) {
+        this.sucessCountDown = this.dismissSecs
+      } else {
+        this.errorCountDown = this.dismissSecs
+      }
+    }
+  },
+  created () {
+    this.updateTable()
+    this.timer = setInterval(this.updateTable, 10000)
+  },
+  beforeDestroy () {
+    clearInterval(this.timer)
+  }
+}
+
+</script>
+
+<style scoped>
+
+.date {
+  font-size: 12px;
+}
+
+.list-pkgs {
+  position: relative;
+  top: 50px;
+}
+
+.table-meta-data {
+  margin-bottom: 20px;
+}
+
+</style>
diff --git a/src/components/package/PackagePage.vue b/src/components/package/PackagePage.vue
new file mode 100644
index 0000000..276519a
--- /dev/null
+++ b/src/components/package/PackagePage.vue
@@ -0,0 +1,126 @@
+<template>
+  <div class="package-page container">
+    <div class="card container">
+      <div class="row">
+        <div class="col-sm-6 description-container">
+          <summary-package :package="package" class="summary" />
+          <p> Selecione um analizador para verificar os erros: </p>
+          <b-dropdown id="ddown1" :text= "analizers[selectedAnalizer].name" variant="primary" class="m-md-2">
+            <b-dropdown-item v-for="(analizer, index) in analizers" key="'dropdown' + index" @click="onSelectAnalizer(index)"> {{ analizer.name }} </b-dropdown-item>
+          </b-dropdown>
+        </div>
+        <div class="col-sm-6 graph-container">
+          <p> Erros do analizador {{ analizers[selectedAnalizer].name }}: </p>
+          <p> Total: {{ total }} </p>
+          <pie-chart :data="datasets" class="graph" />
+        </div>
+      </div>
+    </div>
+    <errors-table />
+  </div>
+</template>
+
+<script>
+import { mapActions, mapGetters } from 'vuex'
+import * as actionTypes from '../../store/actionTypes.js'
+import * as getterNames from '../../store/getterNames.js'
+import SummaryPackage from './SummaryPackage'
+import ErrorsTable from './ErrorsTable'
+import PieChart from './PieChart'
+
+export default {
+  components: {
+    SummaryPackage,
+    ErrorsTable,
+    PieChart
+  },
+  props: {
+    package: {
+      type: Object,
+      default () {
+        return {}
+      }
+    }
+  },
+  data () {
+    return {
+      selectedAnalizer: 0
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.analizers,
+      getterNames.reports
+    ]),
+    datasets () {
+      const labels = Object.keys(this.reports)
+      const data = labels.map((key) => {
+        return this.reports[key]
+      })
+      const datasets = [{
+        label: 'Errors',
+        data: data,
+        backgroundColor: ['#CC0000', '#ffbb33', '#0099CC']
+      }]
+      return { labels, datasets }
+    },
+    total () {
+      const labels = Object.keys(this.reports)
+      const data = labels.map((key) => {
+        return this.reports[key]
+      })
+      return data.reduce(function (a, b) { return a + b }, 0)
+    }
+  },
+  methods: {
+    ...mapActions([
+      actionTypes.SET_SELECTED
+    ]),
+    onSelectAnalizer (index) {
+      this.selectedAnalizer = index
+      this.setSelected(this.analizers[this.selectedAnalizer].id)
+    }
+  },
+  mounted () {
+    this.setSelected(this.analizers[this.selectedAnalizer].id)
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+.package-page {
+  margin-top: 20px;
+}
+
+.card {
+  margin-bottom: 20px;
+}
+
+.description-container {
+  display: flex;
+  flex-direction: column;
+  align-items: center;
+  p {
+    text-align: center;
+  }
+}
+
+.graph-container {
+  padding-top: 2vh;
+  display: flex;
+  flex-direction: column;
+  justify-content: center;
+  p {
+    text-align: center;
+  }
+}
+
+.summary {
+  margin-top: 15px;
+}
+
+.graph {
+  padding: 10px 0;
+  margin: 0 auto;
+}
+</style>
diff --git a/src/components/package/PieChart.vue b/src/components/package/PieChart.vue
new file mode 100644
index 0000000..d91f5c7
--- /dev/null
+++ b/src/components/package/PieChart.vue
@@ -0,0 +1,30 @@
+<template>
+ <div>
+  <pie-chart :chart-data="data" :options="options"></pie-chart>
+ </div>
+</template>
+
+<script>
+import PieChart from '../../helpers/Charts.js'
+export default {
+  components: {
+    'pie-chart': PieChart
+  },
+  props: {
+    data: {
+      type: Object,
+      required: true
+    },
+    options: {
+      type: Object,
+      required: false
+    }
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+  div {
+    max-width: 300px;
+  }
+</style>
\ No newline at end of file
diff --git a/src/components/package/Search.vue b/src/components/package/Search.vue
new file mode 100644
index 0000000..f6098f1
--- /dev/null
+++ b/src/components/package/Search.vue
@@ -0,0 +1,139 @@
+<template>
+  <div class="search-wrapper">
+    <div class="row">
+      <div class="text-center col-md-12">
+        <h1>Find Packages</h1>
+      </div>
+    </div>
+    <div class="row">
+      <div class="text-center col-md-12">
+        <h4>2 new packages recently added</h4>
+      </div>
+    </div>
+    <div class="row">
+        <div class="col-md-3"></div>
+        <div class="col-md-6 text-center">
+          <div class="wrapper">
+            <input v-model="term" placeholder="Find packages..." type="text" />
+            <a href="">
+              <icon class="search-icon" name="search" scale="1.5"></icon>
+            </a>
+          </div>
+        </div>
+    </div>
+  </div>
+</template>
+
+<script>
+import { mapActions, mapGetters } from 'vuex'
+import * as actionTypes from '../../store/actionTypes.js'
+import * as getterNames from '../../store/getterNames.js'
+
+export default {
+  data () {
+    return {
+      term: '',
+      searchDef: {
+        show: false
+      },
+      currentRow: null
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.allPackages
+    ])
+  },
+  watch: {
+    term: function (val, oldVal) {
+      console.log(val)
+      this.fetchPackages(val)
+    }
+  },
+  methods: {
+    ...mapActions([
+      actionTypes.FETCH_PACKAGES
+    ]),
+    showPackage () {
+      // show the analysis here
+    }
+  },
+  created () {
+    this.fetchPackages(this.term)
+  }
+}
+
+</script>
+
+<style scoped>
+
+@media only screen and (max-width : 767px) {
+  .search-icon {
+    margin-left: -35px!important;
+  }
+}
+
+@media only screen and (max-width : 480px) {
+  .search-icon {
+    margin-left: 150px!important;
+  }
+}
+
+.search-wrapper {
+  /*background-image: url('/static/grey.jpg');*/
+  background-size: cover;
+  background-color: #eee;
+  min-height: 200px;
+ }
+
+h1 {
+  margin-top: 30px;
+  text-transform: uppercase;
+  font-size: 4em;
+  line-height: 1;
+  font-weight: 200;
+}
+
+h4 {
+  margin: 5px 0;
+  font-size: 1.3em;
+  font-weight: 300;
+  color: #2066AC;
+}
+
+.wrapper {
+  position: relative;
+  padding:0;
+  margin-bottom: 30px;
+ }
+
+.search-icon {
+  position: absolute;
+  font-size: 40px;
+  line-height: 30px;
+  margin-left: -35px;
+  top: 30px;
+  }
+
+  a {
+   text-decoration: none;
+  }
+
+  a:visited {
+   color: black;
+ }
+
+  input {
+    margin-top: 20px;
+    padding: 8px 5px;
+    width: 400px;
+    font-size: 1.2em;
+    line-height: 30px;
+  }
+
+ input:focus {
+   border-color: rgb(31, 48, 90);
+   box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(31, 48, 90, 0.6);
+ }
+
+</style>
diff --git a/src/components/package/SummaryPackage.vue b/src/components/package/SummaryPackage.vue
new file mode 100644
index 0000000..a7e7394
--- /dev/null
+++ b/src/components/package/SummaryPackage.vue
@@ -0,0 +1,32 @@
+<template>
+  <b-card class="summary-package"  bg-variant="dark" text-variant="white" :title="package.name">
+    <p class="card-text"> {{ package.version }} </p>
+    <p> {{ package.lastUpdate }} </p>
+  </b-card>
+</template>
+
+<script>
+export default {
+  props: {
+    package: {
+      type: Object,
+      default () {
+        return {
+          name: 'Some name',
+          version: 'Some version',
+          lastUpdate: '26/09/2017'
+        }
+      }
+    }
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+.summary-package {
+  width: 30%;
+  max-width: 300px;
+  min-width: 250px;
+  height: 40%;
+}
+</style>
diff --git a/src/components/shared/HeaderK.vue b/src/components/shared/HeaderK.vue
index d2e69e5..15fca79 100644
--- a/src/components/shared/HeaderK.vue
+++ b/src/components/shared/HeaderK.vue
@@ -1,27 +1,22 @@
 <template>
-  <div>
-    <md-toolbar>
-      <md-layout md-order="start">
-        <md-layout :md-flex="5">
-          <md-icon>menu</md-icon>
-        </md-layout>
-        <md-layout :md-flex="15">
-          <h2 class="md-title;">Kiskadee</h2>
-        </md-layout>
-        <md-layout md-flex-offset="50" >
-            <form novalidate @submit.stop.prevent="submit">
-              <md-input-container>
-                <md-input placeholder="Find package"></md-input>
-              </md-input-container>
-            </form>
-        </md-layout>
-      </md-layout>
-    </md-toolbar>
-  </div>
+  <b-navbar toggleable="md" type="dark" variant="dark" class="navbar">
+    <b-nav-toggle target="nav_text_collapse" />
+    <b-navbar-brand href="home" class="logo">
+      <img src="../../assets/kiskadee-logo.png" width="35" height="35" class="d-inline-block align-top" alt="logo">
+      <router-link :to="{ name: 'home' }">
+        <h2 class="name">{{ say_my_name }}</h2>
+      </router-link>
+    </b-navbar-brand>
+    <b-collapse is-nav id="nav_text_collapse">
+      <b-nav is-nav-bar>
+      </b-nav>
+    </b-collapse>
+  </b-navbar>
 </template>
 
 <script>
 export default {
+  name: 'header-kiskadee',
   data () {
     return {
       say_my_name: 'Kiskadee'
@@ -32,5 +27,31 @@ export default {
 </script>
 
 <style scoped>
+@import url('https://fonts.googleapis.com/css?family=Comfortaa:700');
 
+a:link, a:visited {
+  font-family: 'Comfortaa', cursive;
+  color: #fff;
+  text-decoration: none;
+}
+
+.navbar {
+  background: #072c62 !important;
+  height: 55px;
+}
+
+.name {
+  display: inline-block;
+  padding-top: 2px;
+  padding-left: 2px;
+}
+
+.name:hover {
+  color: #3e6eb3;
+}
+
+.logo {
+  padding-top: 13px;
+  text-decoration: none !important;
+}
 </style>
diff --git a/src/helpers/Charts.js b/src/helpers/Charts.js
new file mode 100644
index 0000000..15b3c86
--- /dev/null
+++ b/src/helpers/Charts.js
@@ -0,0 +1,12 @@
+import Chartjs from 'vue-chartjs'
+const { reactiveProp } = Chartjs.mixins
+
+var PieChart = Chartjs.Pie.extend({
+  mixins: [reactiveProp],
+  props: ['options'],
+  mounted () {
+    this.renderChart(this.chartData, this.options)
+  }
+})
+
+export default PieChart
diff --git a/src/main.js b/src/main.js
index 668d5fd..ce518c8 100644
--- a/src/main.js
+++ b/src/main.js
@@ -1,44 +1,30 @@
+// Vue Config
 import Vue from 'vue'
 import App from './App'
-
 import VueRouter from 'vue-router'
-import { routes } from './router/routes'
-import store from './store'
 
-import DataTables from 'vue-data-tables'
-import ElementUI from 'element-ui'
-import 'element-ui/lib/theme-default/index.css'
-import lang from 'element-ui/lib/locale/lang/en'
-import locale from 'element-ui/lib/locale'
-import BootstrapVue from 'bootstrap-vue'
-
-locale.use(lang)
+// Vuex Setup
+import store from './store'
 
-Vue.use(ElementUI)
-Vue.use(DataTables)
-import VueMaterial from 'vue-material'
-Vue.use(VueMaterial)
+// Router Setup
+import { routes } from './router/routes'
 
+// Library Imports
+import 'vue-awesome/icons'
+import Icon from 'vue-awesome/components/Icon'
+import BootstrapVue from 'bootstrap-vue'
 import 'bootstrap/dist/css/bootstrap.css'
 import 'bootstrap-vue/dist/bootstrap-vue.css'
 
-Vue.use(BootstrapVue)
-
+// Plugin Setup
 Vue.use(VueRouter)
-
-Vue.material.registerTheme('default', {
-  primary: {
-    color: 'teal',
-    hue: '500'
-  },
-  accent: 'black',
-  warn: 'black',
-  background: 'white'
-})
+Vue.use(BootstrapVue)
+Vue.component('icon', Icon)
 
 Vue.config.productionTip = false
 /* eslint-disable no-new */
 
+// Configure Router
 const router = new VueRouter({
   routes: routes
 })
diff --git a/src/router/routes.js b/src/router/routes.js
index 183a362..6d317bb 100644
--- a/src/router/routes.js
+++ b/src/router/routes.js
@@ -1,5 +1,7 @@
 import Home from '../components/home/Home.vue'
+import PackagePage from '../components/package/PackagePage.vue'
 
 export const routes = [
-  { path: '', component: Home }
+  { name: 'home', path: '', component: Home },
+  { name: 'analysis', path: '/analysis/', component: PackagePage, props: route => ({package: route.params.package}) }
 ]
diff --git a/src/store/actionTypes.js b/src/store/actionTypes.js
index bf553e5..3cbf87c 100644
--- a/src/store/actionTypes.js
+++ b/src/store/actionTypes.js
@@ -1 +1,4 @@
+// Packages
 export const FETCH_PACKAGES = 'fetchPackages'
+export const SET_SELECTED = 'setSelected'
+export const FILTERED_PACKAGES = 'filteredPackages'
diff --git a/src/store/getterNames.js b/src/store/getterNames.js
index f1e1aba..2ffb321 100644
--- a/src/store/getterNames.js
+++ b/src/store/getterNames.js
@@ -1 +1,6 @@
+// Packages
 export const allPackages = 'allPackages'
+export const analizers = 'analizers'
+export const reports = 'reports'
+export const errorsList = 'errorsList'
+export const filteredPackages = 'filteredPackages'
diff --git a/src/store/index.js b/src/store/index.js
index 066bf2c..2b4a4c9 100644
--- a/src/store/index.js
+++ b/src/store/index.js
@@ -1,9 +1,11 @@
 import Vuex from 'vuex'
 
 import packages from './modules/packages'
+import analisys from './modules/analysis'
 
 export default new Vuex.Store({
   modules: {
-    packages
+    packages,
+    analisys
   }
 })
